####        

#  ,   - 
read.table("classheight.Rdata")->ch
#   
source("pnorm-showz.R") 

### 

#     (hf)   (hm)
hf<-ch$h[ch$sex=="f"]
hm<-ch$h[ch$sex=="m"]

# ,     -f    ,  -m    

#   ,   (  )
hist(ch$h,plot=F)->histh

#   
nb<-length(histh$breaks)
#   
bmins<-histh$breaks[1:nb-1]
bmaxs<-histh$breaks[2:nb]
#           
bminf<-formatC(bmins,format="f",width=4,digits=2)
bmaxf<-formatC(bmaxs,format="f",width=4,digits=2)
lab<-paste(bminf,bmaxf,sep="-")

#     
mm<-mean(hm)
mf<-mean(hf)
#     
sm<-sd(hm)
sf<-sd(hf)
#    
Nm<-length(hm)
Nf<-length(hf)
#      
sef<-sf/sqrt(Nf)
sem<-sm/sqrt(Nm)

#        
x2b <- function(x) { (x-1.50)/0.05*3+1 } 

#########
###      

#       
histnorm(hf)
#   
mean(hf)
sd(hf)

#     1.60
#
#    
mean(hf)-1.6 -> d16
#       =   (   )
d16/sf  -> z16
#       (   )
d16/sef -> sm16

#   ,    ()
z2p(z16,two.tail=T)  # p=.44,     1.60   
z2p(sm16,two.tail=T) # p=.00005,      1.60  

#             ,
#      (            )
pshow(z16,two.tail=T)
pshow(sm16,two.tail=T)

#            t ( )
t.test(hf,mu=1.6)
#        t (      )
2*(1-pt(sm16,Nf-1))

######### 
###   

## A - 

#   ( ),        
hist(hf,breaks=histh$breaks,plot=F)->histf 
hist(hm,breaks=histh$breaks,plot=F)->histm
#         
cbind(histf$counts,histm$counts)->histb
#         ,   
barplot(t(histb),beside=T,col=c("pink","lightblue"),names.arg=lab,cex.names=0.7,las=1,main=" ",xlab="",ylab=" ")

##    ,     
#    
x<-seq(1,17,by=0.001)
#     
lines(x,dnorm(x,x2b(mf)-1.5,sf*3/0.05)*3*Nf,col="purple",lwd=2)
#    
x<-seq(11,24,by=0.001)
#     
lines(x,dnorm(x,x2b(mm)-0.5,sm*3/0.05)*3*Nm,col="blue",lwd=2)

## B -  

##         ,   
#      
plot(1,xlim=c(1.5,1.9),ylim=c(0,10),type="n",xlab="",ylab="",las=1)
#       
x<-seq(1.5,1.9,by=0.001)
#      ,     ( ,  )
lines(x,dnorm(x,mf,sf)*Nf*0.05,col="purple",lwd=2)
lines(x,dnorm(x,mm,sm)*Nm*0.05,col="blue",lwd=2)

##    ( )
#    
points(mf,dnorm(mf,mf,sf)*Nf*0.05,type="h",col="purple",lty=2)
#    
points(mm,dnorm(mm,mm,sm)*Nm*0.05,type="h",col="blue",lty=2)

##  -  

#    ,    
z<-1 # z=2  95% ; z=5   

#         
x<-seq(mf-z*sef,mf+z*sef,by=0.001)
#    
points(x,dnorm(x,mf,sf)*Nf*0.05,type="h",col="pink")
#         
x<-seq(mm-z*sem,mm+z*sem,by=0.001)
#    
points(x,dnorm(x,mm,sm)*Nm*0.05,type="h",col="lightblue")

#     z           

#             
#         t       
#        , 
#    t       

#####