################
###
###  R IA E 
###
###  ,  2012

#   histnorm, z2p ..
source("pnorm-showz.R")

################

###  :   

#        : 
#       x0    y0,
#           .
#      
#   ,     .
#
#  1    x0      y0!

#  ,    (x0,y0)
N<-30

####   x0
#  ,    -2  +2
x0 <- seq(from=-2,to=2,length.out=N)
# ,          =1.0
x0 <- scale(rnorm(N))[,1]
# ,      (  )
x0 <- rnorm(N)

####   y0
#  ,  (  ,    x0)
y0 <- rnorm(N)
#  ,  ()    x0  
y0 <- x0
#  ,  ()    
y0 <- -x0
###    ,     x0   
#   ,     ( )
y0 <- scale(0.2*x0+rnorm(N))[,1]
y0 <- 0.2*x0+rnorm(N)
#   ,    
y0 <- scale(0.4*x0+rnorm(N))[,1]
y0 <- 0.4*x0+rnorm(N)
#   ,    
y0 <- scale(1.0*x0+rnorm(N))[,1]
y0 <- 1.0*x0+rnorm(N)
#    ,    
y0 <- scale(2.0*x0+rnorm(N))[,1] 
y0 <- 2.0*x0+rnorm(N)

####     
hist(x0)
hist(y0)
cor(x0,y0)

####      (    )
mx<-mean(x0)
my<-mean(y0)
sx<-sqrt(sum((x0-mx)^2)/(N)) # population SD! not sd(x0)
sy<-sqrt(sum((y0-my)^2)/(N))  # population SD! not sd(y0)

####          
sum((x0-mx)*(y0-my))/sx/sy/N # this equals cor(x0,y0)
sum ( (x0-mx)/sx * (y0-my)/sy ) / N # same thing

####    X0-Y0
####
plot(x0,y0,pch=21,bg="lightblue",fg="darkblue",cex=1.25)
#
# ,  
abline(lm(y0~x0),col="purple",lty=2)

####
####        
####
#    ,      
#
plot(x0,y0,pch=19,col="lightblue",cex=1.25)
text(x0,y0,1:N,col="black",cex=0.75)

#       
abline(v=mx,col="blue",lty=3)
abline(h=my,col="blue",lty=3)

#      ,  
rug(x0,side=1,col="blue")
rug(y0,side=2,col="purple")

###      
#
i<-3 #   (    )
#
#      
arrows(x0[i],y0[i],mx,y0[i],col="red",length=0.1)
arrows(x0[i],y0[i],x0[i],my,col="red",length=0.1)
text(mx+(x0[i]-mx)/2,y0[i],expression(paste("z"[x])),pos=3,col="red")
text(x0[i],my+(y0[i]-my)/2,expression(paste("z"[y])),pos=4,col="red")

####        
####     ,    x0-y0

################

###  :     

#     
rxy<-cor(x0,y0)
#   t
t<-rxy*sqrt(N-2)/sqrt(1.0-rxy^2)
#      (= )
t2p(t,N-2,two.tail=T)
#    ,    
cor.test(x0,y0)

####       

#        : 
#             .
#                
#    ,      .
#             .
#               
#         ()

#     ()   !!

#     (          )
k<-100000
#         
c<-numeric(k)
#    , k 
for (i in 1:k) {    
	x <- rnorm(N)   #        ,   x
	y <- rnorm(N)   #        ,   y
	c[i]<-cor(x,y)  #     x   y,      c
}
#     :
#         ,        
mean(c)
#            ,    1/sqrt(N)
sd(c)

#     
hist(c)
#          , 
#            Gauss
histnorm(c)

#            ,   ;
ref<-0.50 #  
sum(abs(c)>ref)/k #  ,       c
#              ()

#       c (   )
sr<-1.0/sqrt(N)
#        ,    t (  )
d<-0.05354/sr
#     ,    (     c   )
z2p(d,two.tail=T) 

### 