pshow<-function(t=NA,inside=F,tail=F,up.to=F,two.tail=F,limits=4) {

	x<-seq(from=(-limits),to=limits,length.out=200)
	y<-dnorm(x)
	plot(x,y,type="l",las=1,main="Normal curve")
	if (is.na(t)) {
		t<-0
	} else {
		points(t,dnorm(t),type="h",col="red")		
	}
	
	if (inside) {
		t<-abs(t)
		x1<-seq(from=(-t),to=t,length.out=100*round(2*t))
		points(x1,dnorm(x1),type="h",col="grey70")	

		points(-t,dnorm(-t),type="h",col="red")
		points(t,dnorm(t),type="h",col="red")

		points(x,y,type="l")

		return (1-(2*(1-pnorm(t))))
	} 
	if (tail) {
		x1<-seq(from=t,to=limits,length.out=100*round(limits-t))
		points(x1,dnorm(x1),type="h",col="grey70")	

		points(t,dnorm(t),type="h",col="red")

		points(x,y,type="l")

		return(1-pnorm(t))
	}
	if (two.tail) {
		t<-abs(t)

		x1<-seq(from=(-limits),to=(-t),length.out=100*round(limits-t))
		points(x1,dnorm(x1),type="h",col="grey70")	
		points(-t,dnorm(t),type="h",col="red")

		x1<-seq(from=t,to=limits,length.out=100*round(limits-t))
		points(x1,dnorm(x1),type="h",col="grey70")	
		points(t,dnorm(t),type="h",col="red")

		points(x,y,type="l")

		return(2*(1-pnorm(t)))
	}
	if (up.to) {
		x1<-seq(from=(-limits),to=(t),length.out=100*round(limits-t))
		points(x1,dnorm(x1),type="h",col="grey70")	

		points(t,dnorm(t),type="h",col="red")

		points(x,y,type="l")

		return(pnorm(t))
	}

}


histnorm<-function(v,xlabel="",norm=T) {

	vt<-na.omit(v) 

	hist(vt,col="grey80",las=1,xlab=xlabel,main="")

	hh<-hist(vt,plot=F)
	barwidth<-diff(hh$breaks[1:2])
	area<-length(vt)*barwidth

	x<-seq(min(vt),max(vt),length.out=100)
	lines(x,dnorm(x,mean(vt),sd(vt))*area,col="red")
	
}


z2p <- function(z,two.tail=F) {
	if (two.tail==T) {
		return(2*(1-pnorm(abs(z))))
	} else {
		return(1-pnorm(abs(z)))
	}
}


p2z <- function(p,two.tail=F) {
	if (two.tail==T) {
		return(-qnorm(p/2))
	} else {
		return(-qnorm(p))
	}
}

t2p <- function(t,df,two.tail=F) {
	if (two.tail==T) {
		return(2*(1-pt(abs(t),df)))
	} else {
		return(1-pt(abs(t),df))
	}
}


p2t <- function(p,df,two.tail=F) {
	if (two.tail==T) {
		return(-qt(p/2,df))
	} else {
		return(-qt(p,df))
	}
}



