##### ΚΕΦΑΛΑΙΟ 11 : ΣΥΓΚΡΙΣΗ ΜΕΣΩΝ ΟΡΩΝ, ΕΝΑ ΔΕΙΓΜΑ

# Εικόνα 11.2 (κατανομή t και κανονική κατανομή)
#
x <- seq (from=-3,to=3,by=0.01)
#
plot(x,dnorm(x),type="l",xlab="t",ylab="f(t)",col="grey50",las=1,ylim=c(0,0.4)) # κανονική (z)
lines(x,dt(x,1),col="grey30",lty=2) # t(1)
lines(x,dt(x,30),col="black",lty=1) # t(30)
#
text(2.5,dt(2.5,1),"t(1)",col="grey30",pos=3)
text(1.8,dt(1.8,30),"t(30)",pos=4)
text(2.5,dnorm(2.5),"t(\u221e) = z",col="grey50",pos=2)

# Σύγκριση άγχους δείγματος με το γενικό πληθυσμό
#
# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch11
read.table("chapter11.Rdata")->ch11

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch11)

# Σύγκριση με την τιμή αναφοράς με το κριτήριο t για ένα δείγμα
t.test(ch11$anxiety,mu=35.7)

# Υπολογισμός του κριτηρίου από τα δεδομένα
m<-mean(ch11$anxiety)   # μέσος όρος
s<-sd(ch11$anxiety)     # τυπική απόκλιση
N<-length(ch11$anxiety) # πλήθος τιμών (μέγεθος δείγματος)
se<-s/sqrt(N)           # τυπικό σφάλμα
t<-(m-35.7)/se          # κριτήριο t για τιμή αναφοράς 35.7
df<-N-1                 # βαθμοί ελευθερίας
p<-2*(1-pt(t,df))       # στατιστική σημαντικότητα για αμφίπλευρο έλεγχο

# Υπολογισμός διαστήματος εμπιστοσύνης 95%
tc<-qt((1-0.05/2),df)   # κρίσιμη τιμή κριτηρίου
ci<-tc*se               # μονόπλευρο διάστημα στην κλίμακα μέτρησης
CI95<-c(m-ci,m+ci)      # διάστημα εμπιστοσύνης του μέσου όρου
