###### ΚΕΦΑΛΑΙΟ 17 : ΣΥΓΚΡΙΣΗ ΣΥΧΝΟΤΗΤΩΝ ΚΑΤΗΓΟΡΙΩΝ

## Α. ΤΟ χ2 ΓΙΑ ΜΙΑ ΚΑΤΗΓΟΡΙΚΗ ΜΕΤΑΒΛΗΤΗ
#
# Κατασκευή του πλαισίου δεδομένων
#ch17.1<-data.frame(meleti=as.factor(c(rep("Μεθοδική",51),rep("Ακανόνιστη",27),rep("Συνδυαστική",42))))

# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch17.1
read.table("chapter17_1.Rdata")->ch17.1

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch17.1)
summary(ch17.1)

# Πίνακας συχνοτήτων της μοναδικής μεταβλητής του πλαισίου
table(ch17.1)->t1

# Οι αναμενόμενες συχνότητες είναι ίσες με το πλήθος των μετρήσεων δια τον αριθμό των κατηγοριών
e1<-rep(sum(t1)/length(t1),length(t1))

# Υπολογισμός του κριτηρίου χ2 
# διαιρώντας τις τετραγωνικές διαφορές παρατηρούμενων-αναμενόμενων τιμών με τις αναμενόμενες τιμές
chi2<-sum( (t1-e1)^2 / e1 )
# Οι βαθμοί ελευθερίας είναι ένας λιγότερος από το πλήθος των κατηγοριών
df<-length(t1)-1
# Πιθανότητα υπέρβασης της υπολογισμένης τιμής του κριτηρίου, από τη συνάρτηση pchisq
pchi<-1.0-pchisq(chi2,df)

# Απευθείας υπολογισμός του κριτηρίου χ2 χρησιμοποιώντας τη συνάρτηση chisq.test
chisq.test(table(ch17.1))

####

## Α. ΤΟ χ2 ΓΙΑ ΔΥΟ ΚΑΤΗΓΟΡΙΚΕΣ ΜΕΤΑΒΛΗΤΕΣ
#
# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch17.1
read.table("chapter17_2.Rdata")->ch17.2
# Αναδιάταξη του παράγοντα «performance» ώστε να είναι σε σειρά επίδοσης
ch17.2$performance<-ordered(ch17.2$performance,levels=c("Low","Medium","High"))

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch17.2)
summary(ch17.2)

# Πίνακας διασταύρωσης των δύο μεταβλητών του πλαισίου
table(ch17.2)->t

# Αθροίσματα περιθωρίου σειρών
srow<-apply(t,1,sum)
# Αθροίσματα περιθωρίου στηλών
scol<-apply(t,2,sum)
# Συνολικό άθροισμα συχνοτήτων
sall<-sum(t)
# Υπολογισμός αναμενόμενων συχνοτήτων από το γινόμενων αθροισμάτων περιθωρίου δια του συνόλου
e2<-matrix(srow,nrow=2,ncol=3,byrow=F)*matrix(scol,nrow=2,ncol=3,byrow=T)/sall
# Προαιρετικά, προσδιορισμός ετικετών του πίνακα αναμενόμενων τιμών
rownames(e2)<-rownames(t)
colnames(e2)<-colnames(t)
# Στρογγυλοποιημένες αναμενόμενες τιμές
round(e2,2)

# Υπολογισμός του κριτηρίου χ2 βάσει του γενικού τύπου
chisq<-sum( (t-e2)^2 / e2 )
# Οι βαθμοί ελευθερίας είναι το γινόμενο των β.ε. ανά μεταβλητή
df<-(nrow(t)-1)*(ncol(t)-1)
# Πιθανότητα υπέρβασης της υπολογισμένης τιμής του κριτηρίου
pchi<-1.0-pchisq(chisq,df)

# Απευθείας υπολογισμός του κριτηρίου χ2 χρησιμοποιώντας τη συνάρτηση chisq.test
chisq.test(table(ch17.2))->cht

# Παρατηρούμενες και αναμενόμενες τιμές, κατάλοιπα, και όλες οι πληροφορίες του κριτηρίου 
cht$observed
round(cht$expected,1)
round(cht$residuals,1)
cht

####

# Άλλοι συντελεστές της σχέσης μεταξύ των μεταβλητών, από τη βιβλιοθήκη vcd
vcd::assocstats(table(ch17.2))

