##### ΚΕΦΑΛΑΙΟ 3 : ΠΑΡΟΥΣΙΑΣΗ ΔΕΔΟΜΕΝΩΝ 

## Α. ΚΑΤΗΓΟΡΙΚΑ ΔΕΔΟΜΕΝΑ
#
# Διαβάζουμε τα δεδομένα από το αποθηκευμένο αρχείο 
read.table("chapter3_1.Rdata") -> ch31

# Σε περίπτωση που θέλουμε να επεξεργαστούμε τα δεδομένα
#fix(ch31)

# Περιληπτική αναφορά των δεδομένων - καταμέτρηση ανά κατηγορία (σε αλφαβητική σειρά)
summary(ch31)
# Αν θέλουμε να ορίσουμε τη σωστή σειρά των μορφωτικών επιπέδων 
# ch31$education <- ordered(ch31$education,levels(ch31$education)[c(5,2,4,3,1)])

# Απλό ραβδόγραμμα συχνοτήτων 
plot(ch31)
# Η παραπάνω απλή μορφή λειτουργεί επειδή υπάρχει μόνο μία στήλη δεδομένων, κανονικά έπρεπε να προσδιορίσουμε:
# plot(ch31$education)
# Καλλωπισμένη και συμπληρωμένη εκδοχή
# plot(ch31,xlab="Μορφωτικό επίπεδο",ylab="Πλήθος ατόμων",cex.names=0.85,las=1)

# Μέτρηση του πλήθους των στοιχείων (=αριθμός ατόμων)
length(ch31$education)

# Πίνακας συχνοτήτων
table(ch31) -> t3
# Άθροισμα συχνοτήτων, πρέπει να ισούται με το πλήθος (length)
sum(t3)

# Πίνακας σχετικών συχνοτήτων ως ποσοστά %, στρογγυλοποιημένος σε ακέραια ποσοστά
round(t3/sum(t3)*100.0) -> r3
# Άθροισμα σχετικών συχνοτήτων, πρέπει να ισούται με 100
sum(r3)

# Κυκλικό διάγραμμα των σχετικών συχνοτήτων
pie(r3)
# Κυκλικό διάγραμμα με τα ποσοστά αντί για τα μορφωτικά επίπεδα
# pie(r3,labels=r3)
# Κυκλικό διάγραμμα με τα ποσοστά και τα αντίστοιχα μορφωτικά επίπεδα
# pie(r3,labels=paste(names(r3),r3,"%"))

# Ραβδόγραμμα συχνοτήτων
barplot(t3)
# Φαντεζί εκδοχή
# barplot(r3,cex.names=0.85,las=1,col=rainbow(5),ylab="Ποσοστό (%)")

# Ακιδωτό διάγραμμα συχνοτήτων
plot(t3)
# Ακιδωτό διάγραμμα σχετικών συχνοτήτων
plot(r3)

# Πολύγωνο σχετικών συχνοτήτων
plot(t3,type="l")
# Καλλωπισμένο πολύγωνο σχετικών συχνοτήτων
# plot(r3,type="l",xlab="Μορφωτικό επίπεδο",ylab="Ποσοστό ατόμων",las=1,ylim=c(0,50))

#####

## Β. ΠΟΣΟΤΙΚΑ ΔΕΔΟΜΕΝΑ
#
# Διαβάζουμε τα δεδομένα από το αποθηκευμένο αρχείο 
read.table("chapter3_2.Rdata") -> ch32

# Σε περίπτωση που θέλουμε να επεξεργαστούμε τα δεδομένα
#fix(ch32)

# Περιληπτική αναφορά των δεδομένων - δείκτες κεντρικής τάσης και τεταρτημόρια
summary(ch32)

# Διάγραμμα μίσχου-φύλλων
stem(ch32$age)
# Ανάθεση στήλης δεδομένων σε απλή μεταβλητή
age<-ch32$age

# Μέσος όρος
mean(age)
# Διάμεσος
median(age)

# Πίνακας συχνοτήτων 
table(age)->ta
# Ακιδωτό διάγραμμα συχνοτήτων
plot(ta)

# Ταξινόμηση ηλικιών κατά αύξουσα σειρά συχνότητας
sort(ta)

# Ιστόγραμμα ηλικιών
hist(age)
# Καλλωπισμένες και φαντεζί εκδοχές, ανά πενταετία, συμπληρωμένες με ενδείξεις
# hist(age,breaks=14,xlab="Ηλικία (έτη)",ylab="Αριθμός ατόμων",main="Ιστόγραμμα ηλικιών",las=1,col=rainbow(14))
# hist(age,breaks=14,col=gray(14:1/14),add=T)

# Πολύγωνο συχνότητας ηλικιών, σελ. 73
plot(ta,type="l",las=1,ylim=c(1,6),xlab="Ηλικία",ylab="Percent")

# Ομαδοποιημένη κατανομή συχνότητας, σελ. 61
# Βασίζεται στη συνάρτηση ιστογράμματος, χωρίς εμφάνιση του διαγράμματος, για την καταμέτρηση ανά ομάδα τιμών
hist(age,breaks=1:14*5+12.5,plot=F)->h32 # Οι στήλες mids και counts του αποτελέσματος περιέχουν τις επιθυμητές συχνότητες
# n<-length(h32$counts)    # Πλήθος ηλικιακών κατηγοριών
# counts<-h32$counts[n:1]  # Αντιστροφή σειράς κατηγοριών, για να ταιριάζει με τον πίνακα του βιβλίου
# mids<-h32$mids[n:1]      # Αντιστροφή σειράς κατηγοριών, για να ταιριάζει με τον πίνακα του βιβλίου
counts<-h32$counts # ορθή σειρά, σύμφωνα με τη φορά της αθροιστικής συχνότητας
mids<-h32$mids       # ορθή σειρά, σύμφωνα με τη φορά της αθροιστικής συχνότητας
cum32<-cumsum(counts)         # Υπολογισμός αθροιστικής συχνότητας
rel32<-100*counts/sum(counts) # Υπολογισμός σχετικής συχνότητας
cumrel32<-cumsum(rel32)       # Υπολογισμός αθροιστικής σχετικής συχνότητας
agegroup<-paste(mids-2,mids+2,sep="-") # Ετικέτες ηλικιακών κατηγοριών (από-μέχρι)
data.frame(cbind(agegroup,mids,counts,cum32,round(rel32,1),round(cumrel32,1)))->gf32
colnames(gf32)<-c("Διαστήματα τιμών","Μέση τιμή","Απόλυτη συχνότητα","Αθροιστική απ.συχν.","Σχετική συχνότητα","Αθροιστική σχ.συχν.")
# Το πλαίσιο δεδομένων gf32 περιέχει τον επιθυμητό πίνακα

# δεύτερη εκδοχή, 26 Μαρτίου 2012