##### ΚΕΦΑΛΑΙΟ 9 : ΥΠΟΛΟΓΙΣΜΟΣ ΔΕΙΚΤΗ ΣΥΣΧΕΤΙΣΗΣ

## Α. ΔΕΙΚΤΗΣ r ΤΟΥ PEARSON

# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch9.1
read.table("chapter9_1.Rdata")->ch9.1

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch9.1)
summary(ch9.1)

# Αυτόματο διάγραμμα σκεδασμού των δεδομένων
plot(ch9.1)
# Διάγραμμα σκεδασμού προσαρμοσμένο στην εικόνα 9.1 (σελ. 217)
plot(new_test~old_test,ch9.1,xlab="Παλιό τεστ",ylab="Νέο τεστ",xlim=c(0,25),ylim=c(0,20),las=1)

# Υπολογισμός δείκτη συσχέτισης και στατιστική σημαντικότητα
cor.test(ch9.1$old_test,ch9.1$new_test)

# Εναλλακτικός υπολογισμός δείκτη συσχέτισης από τη βιβλιοθήκη Hmisc
Hmisc::rcorr(as.matrix(ch9.1))

## Β. ΔΕΙΚΤΗΣ ρ ΤΟΥ SPEARMAN

# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch9.2
read.table("chapter9_2.Rdata")->ch9.2

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch9.2)
summary(ch9.2)

# Αυτόματο διάγραμμα σκεδασμού των δεδομένων
plot(ch9.2)

# Υπολογισμός δείκτη συσχέτισης και στατιστική σημαντικότητα
cor.test(ch9.2$intelligence,ch9.2$mechanical,method="spearman")

# Εναλλακτικός υπολογισμός δείκτη συσχέτισης από τη βιβλιοθήκη Hmisc
Hmisc::rcorr(as.matrix(ch9.2),type="spearman")->c
# Τμηματική παρουσίαση των στοιχείων, με στρογγυλοποίηση
round(c$r,3)
c$n
round(c$P,3)

## Γ. ΔΕΙΚΤΗΣ ΜΕΡΙΚΗΣ ΣΥΣΧΕΤΙΣΗΣ

# Διαβάζουμε τα δεδομένα του κεφαλαίου από το αντίστοιχο αρχείο στο πλαίσιο δεδομένων ch9.2
read.table("chapter9_3.Rdata")->ch9.3

# Βασικός έλεγχος του πλαισίου δεδομένων
str(ch9.3)
summary(ch9.3)

# Πίνακας ενδοσυσχετίσεων από τη βιβλιοθήκη Hmisc
Hmisc::rcorr(as.matrix(ch9.3))

# Απλός υπολογισμός μερικής συσχέτισης από τα κατάλοιπα
rx<-residuals(lm(anxiety~years_work,ch9.3))
ry<-residuals(lm(satisfaction~years_work,ch9.3))
cor(rx,ry)->pcor
# Υπολογισμός στατιστικής σημαντικότητας βάσει κριτηρίου t
df<- nrow(ch9.3)-ncol(ch9.3)
t <- pcor/sqrt((1 - pcor^2)/df) 
p <- 2.0*(1.0-pt(t,df))

# Συντελεστής μερικής συσχέτισης από τη βιβλιοθήκη psych
psych::partial.r(ch9.3,c(1,2),3)[1,2]
